<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: bridge_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_9f7e23c4ca0949979e92cf4f8713ec23.html">bridge</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">bridge_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_BRIDGe_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_BRIDGe_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../pipe/pipe_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ---------------------------------------------------------------------------------------- </span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">struct </span>connect_to_ip_and_port</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        connect_to_ip_and_port (</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;            <span class="keyword">const</span> std::string&amp; ip,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        );</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    };</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    connect_to_ip_and_port connect_to (</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">const</span> network_address&amp; addr</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    );</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">struct </span>listen_on_port</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        listen_on_port(</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        );</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    };</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">typename</span> pipe_type</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        &gt;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    bridge_transmit_decoration&lt;pipe_type&gt; transmit ( </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        pipe_type&amp; p</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    ); </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">typename</span> pipe_type</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        &gt;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    bridge_receive_decoration&lt;pipe_type&gt; receive ( </div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        pipe_type&amp; p</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    );</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">struct </span>bridge_status</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    {</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        bridge_status(</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        ); </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keywordtype">bool</span> is_connected;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> foreign_port;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        std::string foreign_ip;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    };</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">// ---------------------------------------------------------------------------------------- </span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keyword">class </span>bridge : noncopyable</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    {</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        bridge (</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        );</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U, <span class="keyword">typename</span> V&gt;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        bridge (</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            T network_parameters,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            U pipe1,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            V pipe2 </div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        ); </div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        bridge (</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            T network_parameters,</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            U pipe </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        ); </div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        ~bridge (</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        );</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        );</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        bridge_status get_bridge_status (</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keyword">template</span> &lt; <span class="keyword">typename</span> T, <span class="keyword">typename</span> R &gt;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            listen_on_port network_parameters,</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe,</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        ); </div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="keyword">template</span> &lt; <span class="keyword">typename</span> T, <span class="keyword">typename</span> R &gt;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            listen_on_port network_parameters,</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe,</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        ); </div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keyword">template</span> &lt; <span class="keyword">typename</span> T &gt;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;            listen_on_port network_parameters,</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        );</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keyword">template</span> &lt; <span class="keyword">typename</span> R &gt;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            listen_on_port network_parameters,</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        );</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> R&gt;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            connect_to_ip_and_port network_parameters,</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe,</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        ); </div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> R&gt;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            connect_to_ip_and_port network_parameters,</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe,</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        ); </div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            connect_to_ip_and_port network_parameters,</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            bridge_transmit_decoration&lt;T&gt; transmit_pipe</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        );</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> R&gt;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keywordtype">void</span> reconfigure (</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;            connect_to_ip_and_port network_parameters,</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;            bridge_receive_decoration&lt;R&gt; receive_pipe</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        );</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    };</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160; </div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="comment">// ---------------------------------------------------------------------------------------- </span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160; </div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;}</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160; </div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;<span class="preprocessor">#endif // DLIB_BRIDGe_ABSTRACT_</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160; </div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
